//
// OpenGL Solid Modelling
//
// Nigel Stewart (nigels@eisa.net.au)
// RMIT Department of Manufacturing Systems Engineering
// 25th September 1998
//

#ifndef PLANE_H
#define PLANE_H

#include <vector.h>
#include <point.h>

class Plane : public Vector
{
public:

	Plane();
	Plane(const Vector &,const double);
	Plane(const Vector &,const Vector &);

	const double &d() { return _d; }

	int    inside    (const Vector &pnt) const;
	double insideDist(const Vector &pnt) const;

	Vector intersectRay(const Vector &a,const Vector &b) const;

private:

	double _d;
};

#endif
