//
// OpenGL CSG Rendering
//
// Nigel Stewart (nigels@eisa.net.au)
// RMIT Department of Mechanical and Manufacturing Engineering
// 27th December 1998
//
// OpenGL Info
//

#include <iostream.h>

#ifdef WIN32
#include <windows.h>
#endif

#include <GL/gl.h>
#include <GL/glut.h>

void
OpenGLinfo(ostream &os)
{
	GLint zDepth;
	GLint stencilDepth;
	GLint doubleBuffering;
	GLint rgbaMode;

	glGetIntegerv(GL_DEPTH_BITS,&zDepth);
	glGetIntegerv(GL_STENCIL_BITS,&stencilDepth);
	glGetIntegerv(GL_DOUBLEBUFFER,&doubleBuffering);
	glGetIntegerv(GL_RGBA_MODE,&rgbaMode);


	os << "Double-buffering : " << (doubleBuffering ? "" : "not " ) << "supported." << endl;
	os << "       RGBA mode : " << (rgbaMode ? "" : "not " ) << "enabled." << endl;
	os << "    Depth buffer : " << zDepth << " bit-planes." << endl;
	os << "  Stencil buffer : " << stencilDepth << " bit-planes." << endl;
}
