//
// OpenGL CSG Rendering
//
// Nigel Stewart (nigels@eisa.net.au)
// RMIT Department of Mechanical and Manufacturing Engineering
// 27th December 1998
//
// Calculate a convexity map (k-map)
//

#include <goldfeat.h>

#ifdef WIN32
#include <windows.h>
#endif

#include <GL/gl.h>
#include <GL/glut.h>

#include <atypes.h>
#include <glbuffer.h>
#include <cntsurf.h>

void 
CalcKmap(const Uint mapRes,GLuint dl,char *filename)
{
	GLubyte *buffer = new GLubyte[mapRes*mapRes];
	stencilBuffer kmap(buffer);

	for (Uint y=0; y<mapRes; y++)
		for (Uint x=0; x<mapRes; x++)
		{
			glClear(GL_STENCIL_BUFFER_BIT | GL_COLOR_BUFFER_BIT);

/*
			glMatrixMode(GL_PROJECTION);
			glLoadIdentity();
			gluPerspective(45, 1.33, 0.8, 10.0);

			glMatrixMode(GL_MODELVIEW);		
			glLoadIdentity();

  			gluLookAt(0,0,5, 0,0,0, 0,1,0);
			viewing.glMultMatrix();

			glScaled(zoom,zoom,zoom);

*/
			glPushMatrix();

			glRotated(-90.0+180.0*y/mapRes,1.0,0.0,0.0);
			glRotated(-90.0+180.0*x/mapRes,0.0,1.0,0.0);

			//

			glEnable(GL_DEPTH_TEST);
			glDisable(GL_DITHER);

			//

			glEnable(GL_CULL_FACE);
			glCullFace(GL_BACK);

			glClearDepth(1.0);
			glClearColor(0.5, 0.5, 0.5, 0.0);
		
			glDisable(GL_LIGHTING);

			GLubyte k = countSurfacesVisualise(&dl,1);

			#ifdef _DEBUG
			cout << (int) k << endl;
			#endif

			*(buffer+x+mapRes*y) = k; 

			glFlush();
			glutSwapBuffers();
			glutPostRedisplay();

			glPopMatrix();
	}

	if (filename)
		kmap.writePPM(filename);
}
