#include "Normalised.h"

//
// Generate all normalised strings of base n, length l
// Strings with adjacent identical objects are ignored.
//

static void 
normalised
(
	const OString str,
	const ulong u,
	const ulong n,
	const ulong l,
	StringTest &test
)
{
	if ((l-str.size())<(n-u))
		return;

	if (str.size()==l)
		test.test(str);
	else
	{
		if (u<n)
		{
			OString newStr(str);
			newStr.push_back(u);
			normalised(newStr,u+1,n,l,test);
		}

		if (u)
			for (ulong m=0; m<u; m++)
				if (m!=str[str.size()-1])
				{
					OString newStr(str);
					newStr.push_back(m);
					normalised(newStr,u,n,l,test);
				}
	}
}

//

void
generateNormalised
(
	const ulong n,
	const ulong l,
	StringTest &test
)
{
	normalised(OString(n),0,n,l,test);
}

