#include "robGen.h"


//
// Recursive generation
//
// even  indicate the local center, 'a' or permutation of (n-1)
// r     remaining recursions until ready for test
// base  the generated string "so far"
// perms the set of permutations of (n-1) characters
// test  function to test the fitness of each generated string
//

void erraMirrorGen(const int even,const int r,OString base,const vector<OString> &perms,StringTest &test)
{
	//
	// Test the string
	//

	if (r==0)
	{
		//
		// If n is even, each permutation of (n-1) is axis
		//

		if (even)
			for (uint p=0; p<perms.size(); p++)
			{
				OString next = base;		// Copy the base
				next.push_back(0);			// insert an 'a'
				OString mirror = next.mirror();
				next += perms[p];			// insert axis
				next += mirror;				// insert mirror of base

				#ifdef _DEBUG
				cout << "Testing: " << next << endl;
				#endif

				test.test(next);
			}
		else
			//
			// If n is odd, use 'a' as axis
			//
			{
				OString mirror = base.mirror();
				OString next = base;				// copy base
				next.push_back(0);					// insert axis
				next += mirror;						// insert mirror

				#ifdef _DEBUG
				cout << "Testing: " << next << endl;
				#endif

				test.test(next);
			}
	}
	else

		//
		// Append to the string base
		//

		for (uint p=0; p<perms.size(); p++)
		{
			OString next = base;		// Copy the base
			next.push_back(0);			// insert an 'a'

			for (uint i=0; i<perms[p].size()-1; i++)
				next.push_back((perms[p])[i]);

			// Recurse

			erraMirrorGen(even,r-1,next,perms,test);
		}
}

// Main loop for Erra "mirror" generation

void 
erraMirror(const ulong n,StringTest &test)
{
	if (n<1)
		return;

	// Generate all permutations of bcdef...

	vector<OString> perms = OString::permutations(n-1);

	// Adjust from abcde.. to bcdef..

	for (uint i=0; i<perms.size(); i++)
		perms[i] += 1;

	// String always begins with abcdef

	OString base(n);

	for (i=0; i<n; i++)
		base.push_back(i);

	if ((n+1)/2 < 2)
	{
		assert((n+1)/2>=2);
		exit(0);
	}

	erraMirrorGen(n%2==0,(n+1)/2 - 2,base,perms,test);
}

