#ifndef _robGen_h
#define _robGen_h

#include <OString.h>
#include <TestString.h>

//
// Generate all normalised strings of a certain form, as
// described by Nik Lygeros (nik.lygeros@desargues.univ-lyon1.fr)
//
// The added twist is to restrict to 'palendromic' cases, as decribed
// by Robert Erra (erra@esiea.fr)...
//
//    ...So there is an interesting connected question:  if we call classically a
//    "palindromic solution" a sequence L that verifies mirror(L)=L (which is
//    not possible for n even > 2), is there always a solution which is
//    palindromic?...
//
// a             +1= 1
// a1a           +2= 3
// a2a2a         +3= 7   -> [a2]a[2a]
// a3a2a3a       +4=12   -> [a3a]2[a3a]
// a4a3a3a4a     +5=19   -> [a4a3]a[3a4a]
// a5a4a4a4a5a   +6=28   -> [a5a4a]4[a4a5a]
// a6a5a5a5a5a6a +7=39	 -> [a6a5a5]a[5a5a6a]
//
// r = (n+1)/2 - 2

void 
erraMirror(const ulong n,StringTest &test);

#endif
