//
// OpenGL Solid Modelling
//
// Nigel Stewart (nigels@eisa.net.au)
// RMIT Department of Mechanical and Manufacturing Engineering
// 11th December 1997
//

#ifndef CNTSURF_H
#define CNTSURF_H

#ifdef WIN32
#include <windows.h>
#endif

#include <GL/gl.h>

typedef enum                                      
{
	COUNT_SURFACES_ALL,
	COUNT_SURFACES_99TH_PERCENTILE
} countSurfacesMode;

//
// NOTE:
// Surface counting will be performed with respect to 
// current culling configuration.
//

GLubyte countSurfaces(GLuint *obj,const GLuint objs,const countSurfacesMode mode);
GLubyte countSurfacesVisualise(GLuint *obj,const GLuint objs);
GLuint  stencilHistogram(GLuint *histogram);

#endif
