#ifndef FONT_H
#define FONT_H

#ifdef WIN32
#include <windows.h>
#endif

#include <GL/gl.h>

// font.cpp
//
// (c) Copyright 1993, Silicon Graphics, Inc.
//               1993, 1994 Microsoft Corporation
//
// ALL RIGHTS RESERVED
//
// This is a modified version of the text
// rendering code from the red OpenGL book.
// 
// The glcursor module provides an easier
// interface than font_print()
//

void fontInit();
void fontPrint(const char *);

//
//	Dimensions (in pixels) of font characters.
//

extern GLuint fontWidth;
extern GLuint fontHeight;

// glcursor.cpp
//
// This module manages a cursor for writing
// text in an OpenGL window.
//

void glCursorInit(GLuint,GLuint,GLuint,GLuint);
void glCursorHome();
void glCursorPrint(const char *);
void glCursorPrintNl(const char *);

#endif
