#include <glcursor.h>
#include <font.h>
#include <string.h>

//
//	Position of window.
//

static GLuint home_x = 0;
static GLuint home_y = 0;

//
//	Dimensions of window.
//

static GLuint width  = 0;
static GLuint height = 0;

//
//	Cursor Position
//

static GLuint pos_x =  0;
static GLuint pos_y =  0;

//
//	Vertical spacing of text.
//

static GLuint vertical_spacing = 1;

//

void 
glCursorInit()
{
	GLint viewport[4];

	glGetIntegerv(GL_VIEWPORT,viewport);

	home_x = viewport[0];
	home_y = viewport[1];
	width  = viewport[2];
	height = viewport[3];
	
	glCursorHome();

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0.0F,(GLfloat) width,0.0F,(GLfloat) height,-1.0F,1.0F);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glTranslatef(0.0F,(GLfloat) (height-fontHeight-vertical_spacing),0.0F);
}

void 
glCursorHome()
{
	pos_x = home_x;
	pos_y = home_y;
}

void 
glCursorPrint(const char *str)
{
	if (str)
	{
		glRasterPos2i(pos_x,pos_y);
		fontPrint(str);
		pos_x += fontWidth*strlen(str);
	}
}

void 
glCursorPrintNl(const char *str)
{
	if (str)
	{
		glRasterPos2i(pos_x,pos_y);
		fontPrint(str);
	}

	pos_x = home_x;
	pos_y -= fontHeight+vertical_spacing;
}




