//
// OpenGL CSG Rendering
//
// Nigel Stewart (nigels@eisa.net.au)
// RMIT Department of Mechanical and Manufacturing Engineering
// 27th December 1998
//
// GoldfeatherRenderingAlgorithm
//
// This module is an OpenGL/C++ implementation
// of the following journal article:
//
// "Near Real-Time CSG Rendering Using Tree Normalisation
// "and Geometric Pruning", Jack Goldfeather, et. al.
// IEEE Computer Graphics and Applications, May 1989, pp 20-28
//

#ifndef GOLDFEAT_H
#define GOLDFEAT_H

#include <csgtree.h>

void GoldfeatherRenderingAlgorithm(const CsgSumOfProducts &sum,bool copy);

// Helper routines

void readDepthBuffer();
void writeDepthBuffer();
void parityApply(const int mask);

//

#ifdef TEMPLATE_BUFFERS
//typedef OpenGLdepthBuffer<GLuint, GL_UNSIGNED_INT> depthBuffer;
typedef OpenGLdepthBuffer<GLushort, GL_UNSIGNED_SHORT> depthBuffer;
typedef OpenGLstencilBuffer<GLubyte,GL_UNSIGNED_BYTE> stencilBuffer;
#else
typedef OpenGLdepthBuffer depthBuffer;
typedef OpenGLstencilBuffer stencilBuffer;
#endif

extern depthBuffer depthCopy;
extern int viewport[4];
extern bool useCopy;

#endif
