#ifndef MCUBES_H
#define MCUBES_H

/*-------------------------------------------------------------------------

 MCUBES (c) Copyright 1994 Steve Anger

   A simple implementation of the marching cubes algorithm for tesselating
 a 3d function. The function is tesselated into triangle faces and saved
 in RAW triangle format (3 x,y,z coord per line). You are free to use all or
 part of this code in your own programs as long as proper credit is given.

 int mcubes (FILE *fp, Func3d func,
             float minx, float miny, float minz,
             float maxx, float maxy, float maxz,
             int xsteps, int ysteps, int zsteps);

 Parameters:
   fp   - Output file handle.
   func - Function to evaluate.
   minx, miny, minz - Minimum x,y,z extents of function.
   maxx, maxy, maxz - Maximum x,y,z extents of function.
   xsteps, ysteps, zsteps - Level of detail in x, y, and z directions.
   return - Returns 1 if call was successful or 0 if it failed.

                                      Steve Anger
                                      CIS: 70714,3113
                                      Internet: 70714.3113@compuserve.com
                                      TGA BBS: (510)524-2780

-------------------------------------------------------------------------*/

#include <stdlib.h>
#include <stdio.h>

typedef float (*Func3d)(float x, float y, float z);

int mcubes (FILE *f, Func3d func,
	    float minx, float miny, float minz,
	    float maxx, float maxy, float maxz,
	    int xsteps, int ysteps, int zsteps);

#endif
