//
// OpenGL Solid Modelling
//
// Nigel Stewart (nigels@eisa.net.au)
// RMIT Department of Mechanical and Manufacturing Engineering
// 11th December 1997
//

#ifndef MESH_H
#define MESH_H

#include <deque.h>

#include <point.h>
#include <triangle.h>

typedef enum
{
	MESH_3DS_BINARY = 0,
	MESH_VRML,
	MESH_OFF,
	MESH_AUTO
} MeshFileType;

class Mesh  
{
public:

	Mesh();
	Mesh(char *filename,MeshFileType type = MESH_AUTO);

	deque<Point>    &point()			{ return _point; }
	deque<Triangle> &triangle()			{ return _triangle; }

	void glDraw();

	ostream &writeAOff(ostream &os);
	ostream &writePOV(ostream &os);

private:

	deque<Point>    _point;
	deque<Triangle> _triangle;

	void loadOff(istream &is);
};

#endif
