#ifndef SUBTRACT_H
#define SUBTRACT_H

#include <csgtree.h>

#ifdef WIN32
#include <windows.h>
#endif

#include <GL/gl.h>

void closestSurfaceBehind(const CsgProduct &product,const vector<unsigned int> &convexity);
void subtractionEngine   (const CsgProduct &product,GLuint layers);


/*
 * Stencil for F and A buffers.
 *
 */

/*

//#define MOST_SIGNIFICANT_BIT	7		// 8 BIT STENCIL BUFFER
#define MOST_SIGNIFICANT_BIT	3		// 4 BIT STENCIL BUFFER

#define FAIL				MOST_SIGNIFICANT_BIT		
//#define FRONT				(FAIL-1)

#define EMPTY				MOST_SIGNIFICANT_BIT
#define SUB					1
#define SUBT				0

#define STENCIL_MASK_ALL	(0xffff & ((1<<MOST_SIGNIFICANT_BIT+1)-1))
#define STENCIL_MASK_NONE	0x00
#define STENCIL_MASK_BIT(x)	(1<<(x))

#define SETUP_MASKS(depth,color,stencil) \
	glDepthMask((depth)); \
	glColorMask((color),(color),(color),(color)); \
	glStencilMask((stencil));

#define SETUP_ENABLE(depth,stencil,culling) \
	if (depth)   glEnable(GL_DEPTH_TEST); else glDisable(GL_DEPTH_TEST); \
	if (stencil) glEnable(GL_STENCIL_TEST); else glDisable(GL_STENCIL_TEST); \
	if (culling) glEnable(GL_CULL_FACE);    else glDisable(GL_CULL_FACE); 


typedef enum
{
	FULL_SCREEN,
	QUADRANT
} AcSubtractionMode;

int 
csgSubtract
(
	AcSubtractionMode mode,
	GLuint layers,
	GLuint blank,
	GLuint objs,
	GLuint *obj,
	GLuint *endFacePlane,
	GLuint *kconvex,
	GLubyte *blank_color,
	GLubyte *flute_color,
	GLubyte *background_color		// REVISIT - would like to do without this!
);

int 
csgFirstDeeper
(
	AcSubtractionMode mode,
	GLuint objs,
	GLuint *obj,
	GLuint *endFacePlane,
	GLuint *kconvex,
	GLuint layer
);

int 
csgSubtractSorted
(
	AcSubtractionMode mode,
	GLuint layers,
	GLuint blank,
	GLuint objs,
	GLuint *end_face_first,			// Flute meshed end face first
	GLuint *shank_first,			// Flute meshed shank first
	GLuint *endFacePlane,
	GLuint *kconvex,
	GLubyte *blank_color,
	GLubyte *flute_color,
	GLubyte *background_color		// REVISIT - would like to do without this!
);

class AcMesh;

int 
csgSubtractSortedFullWindow
(
#ifdef _3DX
	AcMesh *blankMesh,
#endif
	GLuint layers,
	GLuint blank,
	GLuint objs,
	GLuint *end_face_first,			// Flute meshed end face first
	GLuint *shank_first,			// Flute meshed shank first
	GLuint *endFacePlane,
	GLuint *kconvex,
	GLubyte *blank_color,
	GLubyte *flute_color,
	GLubyte *background_color		// REVISIT - would like to do without this!
);

*/

#endif
