#include <timer.h>

#ifdef _SGIAPI
#include <sys/times.h>
#include <limits.h>
#include <unistd.h>
#endif

Timer::Timer()
{
	start();
}

Timer::~Timer()
{
	clock_t elapsed;
	elapsed = (_end = clock())-_start;
}

float 
Timer::elapsed() const
{
#ifdef _SGIAPI
	struct tms t;
	return (float) (times(&t)-_start)/CLK_TCK;
#else
	return (float) (clock()-_start)/CLOCKS_PER_SEC;
#endif
}

void 
Timer::start()
{
#ifdef _SGIAPI
        struct tms t;
        _start = _end = times(&t);
#else
        _start = _end = clock();
#endif
}

