//
// OpenGL CSG Rendering
//
// Nigel Stewart (nigels@eisa.net.au)
// RMIT Department of Mechanical and Manufacturing Engineering
// 27th December 1998
//
// Some simple CSG models
//

char defaultTree[] =
"A = sphere	yellow	scale  2.0 2.0 2.0\n"\
"B = box 	green	scale  1.5 1.5 1.5\n"\
"C = cylinder  	orange    scale 2.5 0.8 0.8\n"\
"D = cylinder   orange    scale 2.5 0.8 0.8 rotate 0.0 1.0 0.0 90.0  	\n"\
"Tree = ( A + B ) + ( C + D )\n"\
"Tree = ( A - B )\n"\
"Tree = ( A . B )\n"\
"Tree = ( B - A )\n"\
"Tree = ( C + D )\n"\
"Tree = ( ( A . B ) - ( C + D ) )\n"\
"Tree = ( B - ( C + D ) )\n"\
"Tree = ( ( A - B ) - ( C + D ) ) \n"\
"Tree = ( ( A - B ) + ( C + D ) ) \n"\
"Tree = ( ( A - B ) + ( C - D ) ) - ( A . ( C + D ) )\n";

char gridTree[] =
"WorkPiece = box	   metallicblue   scale 1.0 1.0 0.1\n"\
"\n"\
"GridS00 =    sphere grey    scale 0.2 0.2 0.2 translate -0.8 -0.8  0.2\n"\
"GridS01 =    sphere grey    scale 0.2 0.2 0.2 translate -0.4 -0.8  0.2\n"\
"GridS02 =    sphere grey    scale 0.2 0.2 0.2 translate -0.0 -0.8  0.2\n"\
"GridS03 =    sphere grey    scale 0.2 0.2 0.2 translate  0.4 -0.8  0.2\n"\
"GridS04 =    sphere grey    scale 0.2 0.2 0.2 translate  0.8 -0.8  0.2\n"\
"GridS05 =    sphere grey    scale 0.2 0.2 0.2 translate -0.8 -0.4  0.2\n"\
"GridS06 =    sphere grey    scale 0.2 0.2 0.2 translate -0.4 -0.4  0.2\n"\
"GridS07 =    sphere grey    scale 0.2 0.2 0.2 translate -0.0 -0.4  0.2\n"\
"GridS08 =    sphere grey    scale 0.2 0.2 0.2 translate  0.4 -0.4  0.2\n"\
"GridS09 =    sphere grey    scale 0.2 0.2 0.2 translate  0.8 -0.4  0.2\n"\
"GridS10 =    sphere grey    scale 0.2 0.2 0.2 translate -0.8  0.0  0.2\n"\
"GridS11 =    sphere grey    scale 0.2 0.2 0.2 translate -0.4  0.0  0.2\n"\
"GridS12 =    sphere grey    scale 0.2 0.2 0.2 translate -0.0  0.0  0.2\n"\
"GridS13 =    sphere grey    scale 0.2 0.2 0.2 translate  0.4  0.0  0.2\n"\
"GridS14 =    sphere grey    scale 0.2 0.2 0.2 translate  0.8  0.0  0.2\n"\
"GridS15 =    sphere grey    scale 0.2 0.2 0.2 translate -0.8  0.4  0.2\n"\
"GridS16 =    sphere grey    scale 0.2 0.2 0.2 translate -0.4  0.4  0.2\n"\
"GridS17 =    sphere grey    scale 0.2 0.2 0.2 translate -0.0  0.4  0.2\n"\
"GridS18 =    sphere grey    scale 0.2 0.2 0.2 translate  0.4  0.4  0.2\n"\
"GridS19 =    sphere grey    scale 0.2 0.2 0.2 translate  0.8  0.4  0.2\n"\
"GridS20 =    sphere grey    scale 0.2 0.2 0.2 translate -0.8  0.8  0.2\n"\
"GridS21 =    sphere grey    scale 0.2 0.2 0.2 translate -0.4  0.8  0.2\n"\
"GridS22 =    sphere grey    scale 0.2 0.2 0.2 translate -0.0  0.8  0.2\n"\
"GridS23 =    sphere grey    scale 0.2 0.2 0.2 translate  0.4  0.8  0.2\n"\
"GridS24 =    sphere grey    scale 0.2 0.2 0.2 translate  0.8  0.8  0.2\n"\
"\n"\
"Tree = ( WorkPiece - ( GridS00 + ( GridS01 + ( GridS02 + ( GridS03 + ( GridS04 + ( GridS05 + ( GridS06 + ( GridS07 + ( GridS08 + ( GridS09 + ( GridS10 + ( GridS11 + ( GridS12 + ( GridS13 + ( GridS14 + ( GridS15 + ( GridS16 + ( GridS17 + ( GridS18 + ( GridS19 + ( GridS20 + ( GridS21 + ( GridS22 + ( GridS23 + GridS24 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )\n"\
"Tree = ( WorkPiece + ( GridS00 + ( GridS01 + ( GridS02 + ( GridS03 + ( GridS04 + ( GridS05 + ( GridS06 + ( GridS07 + ( GridS08 + ( GridS09 + ( GridS10 + ( GridS11 + ( GridS12 + ( GridS13 + ( GridS14 + ( GridS15 + ( GridS16 + ( GridS17 + ( GridS18 + ( GridS19 + ( GridS20 + ( GridS21 + ( GridS22 + ( GridS23 + GridS24 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )\n"\
"Tree = ( GridS00 + ( GridS01 + ( GridS02 + ( GridS03 + ( GridS04 + ( GridS05 + ( GridS06 + ( GridS07 + ( GridS08 + ( GridS09 + ( GridS10 + ( GridS11 + ( GridS12 + ( GridS13 + ( GridS14 + ( GridS15 + ( GridS16 + ( GridS17 + ( GridS18 + ( GridS19 + ( GridS20 + ( GridS21 + ( GridS22 + ( GridS23 + GridS24 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) \n"\
"  \n";

char rowTree[] = 
"GridS00 =    sphere blue    scale 0.2 0.2 0.2 translate -1.0 0.0 0.2\n"\
"GridS01 =    sphere blue    scale 0.2 0.2 0.2 translate -0.5 -0.0 0.2\n"\
"GridS02 =    sphere blue    scale 0.2 0.2 0.2 translate -0.0 -0.0 0.2\n"\
"GridS03 =    sphere blue    scale 0.2 0.2 0.2 translate  0.5 0.0 0.2\n"\
"GridS04 =    sphere blue    scale 0.2 0.2 0.2 translate  1.0 0.0 0.2\n"\
"\n"\
"Tree = ( GridS00 + ( GridS01 + ( GridS02 + ( GridS03 + GridS04 ) ) ) ) )\n"\
"\n";

char hollowTree[] =
"A = cylinder  	blue	scale  1.5 1.0 1.0\n"\
"B = cylinder  	green	scale  1.7 0.7 0.7\n"\
"C = cylinder  	red    scale  1.0 0.6 0.6 rotate 0.0 0.0 1.0 90 translate 0.0 1.0 0.0\n"\
"Tree = ( A + ( B + C ) )\n"\
"Tree = ( A - ( B + C ) )\n";

char helixTree[] =
"A = cylinder    metallicblue scale 3 1 1\n"\
"B = helix 	orange	\n"\
"C = helix 	yellow	rotate 1.0 0.0 0.0 180.0  \n"\
"Tree = ( A + B ) \n"\
"Tree = ( A - B )\n"\
"Tree = ( A . B )\n"\
"Tree = ( B - A )\n"\
"Tree = ( B + C )\n"\
"Tree = ( A - ( B + C ) )\n";

char segmentedHelixTree[] =
"A = cylinder    metallicblue scale 3 1 1\n"\
"B = HelixSegment1  orange	\n"\
"C = HelixSegment2  orange	\n"\
"D = HelixSegment3  orange	\n"\
"E = HelixSegment4  orange	\n"\
"F = HelixSegment5  orange	\n"\
"G = HelixSegment6  orange	\n"\
"H = HelixSegment7  orange	\n"\
"I = HelixSegment8  orange	\n"\
"J = HelixSegment9  orange	\n"\
"K = HelixSegment10 orange	\n"\
"L = HelixSegment11 orange	\n"\
"M = HelixSegment12 orange	\n"\
"N = HelixSegment13 orange	\n"\
"O = HelixSegment14 orange	\n"\
"P = HelixSegment15 orange	\n"\
"Q = HelixSegment16 orange	\n"\
"R = HelixSegment17 orange	\n"\
"S = HelixSegment18 orange	\n"\
"T = HelixSegment19 orange	\n"\
"U = HelixSegment20 orange	\n"\
"Tree = ( B + ( C + ( D + ( E + ( F + ( G + ( H + ( I + ( J + ( K + ( L + ( M + ( N + ( O + ( P + ( Q + ( R + ( S + ( T + U ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) \n"\
"Tree = ( A + ( B + ( C + ( D + ( E + ( F + ( G + ( H + ( I + ( J + ( K + ( L + ( M + ( N + ( O + ( P + ( Q + ( R + ( S + ( T + U ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )\n"\
"Tree = ( A - ( B + ( C + ( D + ( E + ( F + ( G + ( H + ( I + ( J + ( K + ( L + ( M + ( N + ( O + ( P + ( Q + ( R + ( S + ( T + U ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )\n";

char swissCheeseTree[] =
"Sphere      = sphere orange scale 2 2 2\n"\
"ClipTop     = box yellow scale 2 0.7 2      translate 0 1.3 0\n"\
"ClipBottom  = box yellow scale 2 0.7 2      translate 0 -1.3 0\n"\
"ClipLeft    = box yellow scale 2.1 0.8 1.05 translate 0 0 1.05\n"\
"ClipRight   = box yellow scale 2.1 0.8 1.05 translate 0 0 1.05 rotate 0 1 0 240\n"\
"Hole1  = sphere orange scale   0.17   0.17   0.17 translate   1.04  -0.44   0.00 rotate 0 1 0 -158.4\n"\
"Hole2  = sphere orange scale   0.23   0.23   0.23 translate   1.48  -0.19   0.00 rotate 0 1 0 -166.4\n"\
"Hole3  = sphere orange scale   0.19   0.19   0.19 translate   1.46   0.35   0.00 rotate 0 1 0 -137.0\n"\
"Hole4  = sphere orange scale   0.19   0.19   0.19 translate   1.84   0.00   0.00 rotate 0 1 0 -128.7\n"\
"Hole5  = sphere orange scale   0.13   0.13   0.13 translate   1.28   0.06   0.00 rotate 0 1 0 -177.6\n"\
"Hole6  = sphere orange scale   0.13   0.13   0.13 translate   0.87  -0.60   0.00 rotate 0 1 0 -149.9\n"\
"Hole7  = sphere orange scale   0.10   0.10   0.10 translate   1.07   0.09   0.00 rotate 0 1 0 -148.6\n"\
"Hole8  = sphere orange scale   0.11   0.11   0.11 translate   1.58   0.15   0.00 rotate 0 1 0 -147.3\n"\
"Hole9  = sphere orange scale   0.17   0.17   0.17 translate   2.04  -0.32   0.00 rotate 0 1 0 -159.2\n"\
"Hole10  = sphere orange scale   0.12   0.12   0.12 translate   2.20   0.37   0.00 rotate 0 1 0 -127.1\n"\
"Hole11  = sphere orange scale   0.12   0.12   0.12 translate   1.69  -0.09   0.00 rotate 0 1 0 -139.8\n"\
"Hole12  = sphere orange scale   0.14   0.14   0.14 translate   1.16   0.42   0.00 rotate 0 1 0 -173.5\n"\
"Hole13  = sphere orange scale   0.10   0.10   0.10 translate   2.12   0.07   0.00 rotate 0 1 0 -163.8\n"\
"Hole14  = sphere orange scale   0.18   0.18   0.18 translate   1.30   0.24   0.00 rotate 0 1 0 -127.5\n"\
"Hole15  = sphere orange scale   0.14   0.14   0.14 translate   1.69   0.12   0.00 rotate 0 1 0 -130.7\n"\
"Hole16  = sphere orange scale   0.16   0.16   0.16 translate   1.73   0.56   0.00 rotate 0 1 0 -135.4\n"\
"Hole17  = sphere orange scale   0.15   0.15   0.15 translate   2.12   0.29   0.00 rotate 0 1 0 -164.1\n"\
"Hole18  = sphere orange scale   0.15   0.15   0.15 translate   1.90   0.17   0.00 rotate 0 1 0 -131.9\n"\
"Hole19  = sphere orange scale   0.17   0.17   0.17 translate   1.96  -0.15   0.00 rotate 0 1 0 -137.6\n"\
"Hole20  = sphere orange scale   0.13   0.13   0.13 translate   1.57   0.28   0.00 rotate 0 1 0 -159.9\n"\
"Hole21  = sphere orange scale   0.10   0.10   0.10 translate   1.88   0.52   0.00 rotate 0 1 0 -163.9\n"\
"Hole22  = sphere orange scale   0.15   0.15   0.15 translate   0.18  -0.58   0.00 rotate 0 1 0 -141.9\n"\
"Hole23  = sphere orange scale   0.12   0.12   0.12 translate   2.16   0.27   0.00 rotate 0 1 0 -138.5\n"\
"Hole24  = sphere orange scale   0.13   0.13   0.13 translate   2.11  -0.57   0.00 rotate 0 1 0 -166.8\n"\
"Hole25  = sphere orange scale   0.15   0.15   0.15 translate   2.20  -0.11   0.00 rotate 0 1 0 -137.3\n"\
"Hole26  = sphere orange scale   0.22   0.22   0.22 translate   1.83   0.35   0.00 rotate 0 1 0 -170.3\n"\
"Hole27  = sphere orange scale   0.18   0.18   0.18 translate   1.99   0.60   0.00 rotate 0 1 0 -131.0\n"\
"Hole28  = sphere orange scale   0.14   0.14   0.14 translate   1.85  -0.29   0.00 rotate 0 1 0 -162.2\n"\
"Hole29  = sphere orange scale   0.16   0.16   0.16 translate   1.86  -0.45   0.00 rotate 0 1 0 -171.6\n"\
"Hole30  = sphere orange scale   0.10   0.10   0.10 translate   0.96  -0.26   0.00 rotate 0 1 0 -124.8\n"\
"Hole31  = sphere orange scale   0.16   0.16   0.16 translate   2.18  -0.46   0.00 rotate 0 1 0 -132.3\n"\
"Hole32  = sphere orange scale   0.13   0.13   0.13 translate   1.71  -0.36   0.00 rotate 0 1 0 -163.4\n"\
"Hole33  = sphere orange scale   0.12   0.12   0.12 translate   1.23   0.30   0.00 rotate 0 1 0 -129.3\n"\
"Hole34  = sphere orange scale   0.21   0.21   0.21 translate   2.15   0.51   0.00 rotate 0 1 0 -173.7\n"\
"Hole35  = sphere orange scale   0.18   0.18   0.18 translate   1.85  -0.04   0.00 rotate 0 1 0 -164.6\n"\
"Hole36  = sphere orange scale   0.18   0.18   0.18 translate   1.48   0.04   0.00 rotate 0 1 0 -139.9\n"\
"Hole37  = sphere orange scale   0.18   0.18   0.18 translate   2.09   0.44   0.00 rotate 0 1 0 -140.5\n"\
"Hole38  = sphere orange scale   0.13   0.13   0.13 translate   1.86  -0.18   0.00 rotate 0 1 0 -155.5\n"\
"Hole39  = sphere orange scale   0.13   0.13   0.13 translate   2.19  -0.15   0.00 rotate 0 1 0 -166.1\n"\
"Hole40  = sphere orange scale   0.15   0.15   0.15 translate   1.01   0.36   0.00 rotate 0 1 0 -129.7\n"\
"Hole41  = sphere orange scale   0.20   0.20   0.20 translate   1.74  -0.60   0.00 rotate 0 1 0 -133.6\n"\
"Hole42  = sphere orange scale   0.10   0.10   0.10 translate   1.79   0.25   0.00 rotate 0 1 0 -150.6\n"\
"Hole43  = sphere orange scale   0.12   0.12   0.12 translate   0.91   0.36   0.00 rotate 0 1 0 -139.7\n"\
"Hole44  = sphere orange scale   0.17   0.17   0.17 translate   1.11   0.07   0.00 rotate 0 1 0 -168.3\n"\
"Hole45  = sphere orange scale   0.29   0.29   0.29 translate   0.61   0.20   0.00 rotate 0 1 0 -164.7\n"\
"Hole46  = sphere orange scale   0.12   0.12   0.12 translate   0.25  -0.58   0.00 rotate 0 1 0 -148.3\n"\
"Hole47  = sphere orange scale   0.22   0.22   0.22 translate   0.77   0.39   0.00 rotate 0 1 0 -150.4\n"\
"Hole48  = sphere orange scale   0.17   0.17   0.17 translate   0.53   0.44   0.00 rotate 0 1 0 -159.1\n"\
"Hole49  = sphere orange scale   0.11   0.11   0.11 translate   1.22   0.12   0.00 rotate 0 1 0 -142.1\n"\
"Hole50  = sphere orange scale   0.10   0.10   0.10 translate   1.28   0.52   0.00 rotate 0 1 0 -175.9\n"\
"\n"\
"Tree = ( Sphere - ( ClipTop + ( ClipBottom + ( ClipLeft + ClipRight ) ) ) )\n"\
"Tree = ( Sphere + ( ClipTop + ( ClipBottom + ( ClipLeft + ( ClipRight + ( Hole1 + ( Hole2 + ( Hole3 + ( Hole4 + ( Hole5 + ( Hole6 + ( Hole7 + ( Hole8 + ( Hole9 + ( Hole10 + ( Hole11 + ( Hole12 + ( Hole13 + ( Hole14 + ( Hole15 + ( Hole16 + ( Hole17 + ( Hole18 + ( Hole19 + ( Hole20 + ( Hole21 + ( Hole22 + ( Hole23 + ( Hole24 + ( Hole25 + ( Hole26 + ( Hole27 + ( Hole28 + ( Hole29 + ( Hole30 + ( Hole31 + ( Hole32 + ( Hole33 + ( Hole34 + ( Hole35 + ( Hole36 + ( Hole37 + ( Hole38 + ( Hole39 + ( Hole40 + ( Hole41 + ( Hole42 + ( Hole43 + ( Hole44 + ( Hole45 + ( Hole46 + ( Hole47 + ( Hole48 + ( Hole49 + Hole50 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) \n"\
"Tree = ( Sphere - ( ClipTop + ( ClipBottom + ( ClipLeft + ( ClipRight + ( Hole1 + ( Hole2 + ( Hole3 + ( Hole4 + ( Hole5 + ( Hole6 + ( Hole7 + ( Hole8 + ( Hole9 + ( Hole10 + ( Hole11 + ( Hole12 + ( Hole13 + ( Hole14 + ( Hole15 + ( Hole16 + ( Hole17 + ( Hole18 + ( Hole19 + ( Hole20 + ( Hole21 + ( Hole22 + ( Hole23 + ( Hole24 + ( Hole25 + ( Hole26 + ( Hole27 + ( Hole28 + ( Hole29 + ( Hole30 + ( Hole31 + ( Hole32 + ( Hole33 + ( Hole34 + ( Hole35 + ( Hole36 + ( Hole37 + ( Hole38 + ( Hole39 + ( Hole40 + ( Hole41 + ( Hole42 + ( Hole43 + ( Hole44 + ( Hole45 + ( Hole46 + ( Hole47 + ( Hole48 + ( Hole49 + Hole50 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) \n" \
"Tree = ( ClipTop + ( ClipBottom + ( ClipLeft + ( ClipRight + ( Hole1 + ( Hole2 + ( Hole3 + ( Hole4 + ( Hole5 + ( Hole6 + ( Hole7 + ( Hole8 + ( Hole9 + ( Hole10 + ( Hole11 + ( Hole12 + ( Hole13 + ( Hole14 + ( Hole15 + ( Hole16 + ( Hole17 + ( Hole18 + ( Hole19 + ( Hole20 + ( Hole21 + ( Hole22 + ( Hole23 + ( Hole24 + ( Hole25 + ( Hole26 + ( Hole27 + ( Hole28 + ( Hole29 + ( Hole30 + ( Hole31 + ( Hole32 + ( Hole33 + ( Hole34 + ( Hole35 + ( Hole36 + ( Hole37 + ( Hole38 + ( Hole39 + ( Hole40 + ( Hole41 + ( Hole42 + ( Hole43 + ( Hole44 + ( Hole45 + ( Hole46 + ( Hole47 + ( Hole48 + ( Hole49 + Hole50 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) \n";

char pipeTree[] = 
"P1a = cylinder  orangered scale 1.0 0.3 0.3 translate 1 0 0 \n"\
"P1b = cylinder  pink      scale 1.01 0.2 0.2 translate 1 0 0 \n"\
"\n"\
"P2a = cylinder  orangered scale 1.0 0.3 0.3 translate 1 0 0  rotate 0 1 0 120  \n"\
"P2b = cylinder  pink      scale 1.01 0.2 0.2 translate 1 0 0  rotate 0 1 0 120 \n"\
"\n"\
"S1  = sphere    orangered scale 0.3 0.3 0.3\n"\
"S2  = sphere    pink      scale 0.2 0.2 0.2\n"\
"\n"\
"Tree = ( P1a + P1b )\n"\
"Tree = ( P1a - P1b )\n"\
"Tree = ( P2a + P2b )\n"\
"Tree = ( P2a - P2b )\n"\
"Tree = ( P1a + ( P1b + ( P2a + P2b ) ) )\n"\
"Tree = ( S1 - ( P1b + ( P2b + S2 ) ) )\n"\
"Tree = ( ( S1 + ( P1a + P2a ) ) - ( S2 + ( P1b + P2b ) ) )\n";
