#include <triangle.h>

Triangle::Triangle()
: _normal(Vector0)
{
	_vertex[0] = _vertex[1] = _vertex[2] = NULL;
}

Triangle::Triangle(Point *a,Point *b,Point *c)
{
	_vertex[0] = a;
	_vertex[1] = b;
	_vertex[2] = c;

	_normal = xProduct
		(
			*(_vertex[1]) - *(_vertex[0]), 
			*(_vertex[2]) - *(_vertex[0])
		);
}

Point *
Triangle::operator[](int index)
{
	return (index>=0 && index<=2 ? _vertex[index] : (Point *) NULL);
}

void 
Triangle::glDraw()
{
	if (_vertex[0]->normal()==Vector0)
	{
		_normal.glNormal();
		_vertex[0]->glVertex();
		_vertex[1]->glVertex();
		_vertex[2]->glVertex();
	}
	else
	{
		_vertex[0]->normal().glNormal();
		_vertex[0]->glVertex();
		_vertex[1]->normal().glNormal();
		_vertex[1]->glVertex();
		_vertex[2]->normal().glNormal();
		_vertex[2]->glVertex();
	}
}

ostream &
Triangle::writePOV(ostream &os)
{
	if (_vertex[0]->normal()==Vector0)
	{
	  os << "triangle { ";

		  os << "< ";
		  os << (*this)[0]->x() << ',';
		  os << (*this)[0]->y() << ',';
		  os << (*this)[0]->z();
		  os << " >,";

		  os << "< ";
		  os << (*this)[1]->x() << ',';
		  os << (*this)[1]->y() << ',';
		  os << (*this)[1]->z();
		  os << " >,";

		  os << "< ";
		  os << (*this)[2]->x() << ',';
		  os << (*this)[2]->y() << ',';
		  os << (*this)[2]->z();
		  os << " >";

	  os << "} " << endl;
	}
	else
	{
	  os << "smooth_triangle { ";

		  os << "< ";
		  os << (*this)[0]->x() << ',';
		  os << (*this)[0]->y() << ',';
		  os << (*this)[0]->z();
		  os << " >, ";

		  os << "< ";
		  os << (*this)[0]->normal().x() << ',';
		  os << (*this)[0]->normal().y() << ',';
		  os << (*this)[0]->normal().z();
		  os << " >, ";

		  os << "< ";
		  os << (*this)[1]->x() << ',';
		  os << (*this)[1]->y() << ',';
		  os << (*this)[1]->z();
		  os << " >, ";

		  os << "< ";
		  os << (*this)[1]->normal().x() << ',';
		  os << (*this)[1]->normal().y() << ',';
		  os << (*this)[1]->normal().z();
		  os << " >, ";

		  os << "< ";
		  os << (*this)[2]->x() << ',';
		  os << (*this)[2]->y() << ',';
		  os << (*this)[2]->z();
		  os << " >, ";

		  os << "< ";
		  os << (*this)[2]->normal().x() << ',';
		  os << (*this)[2]->normal().y() << ',';
		  os << (*this)[2]->normal().z();
		  os << " > ";

		os << "} " << endl;
	}
	return os;
}
